package cz.cvut.fel.pr2.cv8;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.KeyStroke;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.util.Observable;
import java.util.Observer;

/**
 * @author Ondrej Hrstka (ondrej.hrstka at agents.fel.cvut.cz)
 */
public class CountDownAction extends AbstractAction implements Observer {

    private final CounterModel model;

    public CountDownAction(CounterModel model) {
        super("count down");
        this.model = model;
        this.putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke(KeyEvent.VK_D, InputEvent.CTRL_MASK)); // ctrl + D
        model.addObserver(this);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        model.countDown();
    }

    @Override
    public void update(Observable o, Object arg) {
        setEnabled(model.canCountDown());
    }
}
