package cz.cvut.fel.pr2.cv8;

import java.util.Observable;

/**
 * Primitive counter;
 * @author Ondrej Hrstka (ondrej.hrstka at agents.fel.cvut.cz)
 */
public class CounterModel extends Observable {

    public static final int MIN_LIMIT = 0,
                            MAX_LIMIT = 5;

    private int value = 0;

    public CounterModel() {
        setChanged();
    }

    public void countUp() {
        if (!canCountUp()) {
            throw new IllegalStateException("Cannot count up, the limit is reached, value: " + value);
        }

        //private setter would be better to prevent code duplication
        value++;
        setChanged();
        notifyObservers();
    }

    public boolean canCountUp() {
        return value < MAX_LIMIT;
    }
    public void countDown() {
        if (!canCountDown()) {
            throw new IllegalStateException("Cannot count down, the limit is reached, value: " + value);
        }

        //private setter would be better to prevent code duplication

        value--;
        setChanged();
        notifyObservers();
    }

    public boolean canCountDown() {
        return value > MIN_LIMIT;
    }

    public int getValue() {
        return value;
    }

}
